<?php
/*------------------------------------------------------------------------
# Copyright (C) 2012-2015 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

 /**
 *Ark inline content Featured Context Class
 *
 * @package     Inlinecontent.Contexts
 * @subpackage  Inlinecontent.contexts.FlexiContentBlog
 */
 
 
 
class ARKContextsFlexicontentBlog extends ARKContextsFlexicontentArticle
{
			
	public function triggerContentPlugins($rawText)
	{
		
		$item = new stdclass;
					
		$text = '';
		
		if (isset($rawText))
		{
			$pattern = '#<hr\s+id=("|\')system-readmore("|\')\s*\/*>#i';
			$tagPos = preg_match($pattern, $rawText);
			
			if ($tagPos == 0)
			{
				$text = $rawText;
			}
			else
			{
				list ($text, $rawText) = preg_split($pattern, $rawText, 2);
			}
		}

		$item->text = $text;



		$params = $this->getParams();
		$params->set('inline',false);

        //process text
		$app = JFactory::getApplication();
        $leads = $app->getUserState( "inline.arkextensions.flexicontent.leads", array());

    
        if(in_array($this->id,$leads))
        {
           $item->text = $this->striptagsandcut( $item->text, $params->get('lead_cut_text', 400) );

        }
        elseif($params->get('intro_strip_html',1))
        {
            $item->text = $this->striptagsandcut( $item->text, $params->get('intro_cut_text', 200) );
        }


		$dispatcher	= JEventDispatcher::getInstance();
			
		$suppress_arr = array('jcomments', 'jom_comment_bot');
		FLEXIUtilities::suppressPlugins($suppress_arr, 'suppress' );
		
		JPluginHelper::importPlugin('content');
		$dispatcher->trigger('onContentPrepare', array ('com_content.article', &$item, &$params, 0));
	
		// Restore suppressed plugins
		FLEXIUtilities::suppressPlugins($suppress_arr, 'restore' );
		
		return array( 'data'=>$item->text);
	}
	
	public function save($data,$type = 'body')
	{
		if($this->id == null)
			return array( 'title'=>'','data'=>'');	
		if($type == 'title')
		{
			$data['title'] = strip_tags($data['title']); 
			$data['title'] = html_entity_decode($data['title']);
		}
		if(isset($data['articletext']))
		{	
			$data['articletext'] = base64_decode($data['articletext']);	
			$pattern = '#<hr\s+id=("|\')system-readmore("|\')\s*\/*>#i';
			$tagPos	= preg_match($pattern, $data['articletext']);
			
			if ($tagPos == 0)	{
				$data['introtext']= $data['articletext'];
				$data['fulltext']  = '';
			} else 	{
				list($data['introtext'], $data['fulltext']) = preg_split($pattern, $data['articletext'], 2);
				$data['fulltext']  = JString::strlen( trim($data['fulltext'] ) ) ? $data['fulltext']  : '';
			}	
		}	
		
		$app = JFactory::getApplication();
		$app->input->set("isflexicontent", "yes");
		
		// We need to fake joomla's states ... when triggering the before?after save content event
		$fc_state = $this->table->state;
		if ( in_array($fc_state, array(1,-5)) ) $jm_state = 1;           // published states
		else if ( in_array($fc_state, array(0,-3,-4)) ) $jm_state = 0;   // unpublished states
		else $jm_state = $fc_state;                                      // trashed & arch
	
		$datenow = JFactory::getDate();
		$this->table->modified = $datenow->toSQL();
		$this->table->modified_by = JFactory::getUser()->get('id');
		
		$last_version = FLEXIUtilities::getLastVersions($this->id, true);
		$current_version = FLEXIUtilities::getCurrentVersions($this->id, true);
		
		$dispatcher	= JEventDispatcher::getInstance();
		
		$this->table->version = $last_version+1;
		
		JPluginHelper::importPlugin('flexicontent');
		JPluginHelper::importPlugin('content');
		
		
		// Some compatibility steps

		$view = $app->input->get('view', false);
		$app->input->set('view', 'article');	  
		$app->input->set('option', 'com_content');
		
		$this->table->state = $jm_state;
		$dispatcher->trigger('onBeforeContentSave', array('com_content.article', &$this->table, false));
			
		$this->table->save($data);
		
		$dispatcher->trigger('onAfterContentSave', array('com_content.article', &$this->table, false));
		
		$app->input->set('view', 'article');	  
		$app->input->set('option', 'com_content');
		
		// Reverse compatibility steps
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$query->update($db->quoteName('#__content'))->set('state = '. $fc_state )->where('id = '.$this->id );
 		$db->setQuery($query);
		$db->query();
		
		$app->input->set('view', $view);
		$app->input->set('option', 'com_flexicontent');
		
		//We will always be using versioning for inline editing
		
		//Create and store version METADATA information
		
		$version = new stdClass();
        $version->item_id		= (int)$this->table->id;
		$version->version_id	= (int)$last_version+1;
		$version->created		= $this->table->modified;
		$version->created_by 	= $this->table->modified_by;
		$version->comment		= '';
		$db->insertObject('#__flexicontent_versions', $version);
		
		
		//Now duplicate lastversion for fields for consistency

		$sql = 'INSERT INTO #__flexicontent_items_versions(version,field_id,item_id,valueorder,value)';
		
		$query->clear()
			->select(array($last_version+1,'field_id','item_id','valueorder','value'))
			->from('#__flexicontent_items_versions')
			->where('version'.' = '. (int)$last_version)
			->where('item_id'.' = '. (int)$this->id);
			
		$db->setQuery($sql.' '.$query);
		$db->query();	
		
		
		if($type == 'title')
		{	
			$query->clear()
				->select('id')
				->from('#__flexicontent_fields')
				->where($db->quoteName('name').' = '.$db->quote('title'))
				->where($db->quoteName('iscore').'= 1');
			$db->setQuery($query);
			$field_id = $db->loadResult();	
			
			$query->clear()
				->update($db->quoteName('#__flexicontent_items_versions'))->set($db->quoteName('value').' = '. $db->quote($data['title']))->where('field_id = '. (int) $field_id)
				->where('version'.' = '. (int)$last_version+1)
				->where('item_id'.' = '. (int)$this->id);
				$db->setQuery($query);
				$db->query();
		}
		else
		{	
			$query->clear()
				->select('id')
				->from('#__flexicontent_fields')
				->where($db->quoteName('name').' = '.$db->quote('text'))
				->where($db->quoteName('iscore').'= 1');
			$db->setQuery($query);
			$field_id = $db->loadResult();	
			
			$query->clear()
				->update($db->quoteName('#__flexicontent_items_versions'))->set($db->quoteName('value').' = '. $db->quote($data['articletext']))->where('field_id = '. (int) $field_id);
				$db->setQuery($query);
				$db->query();
		}
		
		$dispatcher->trigger('onCompleteSaveItem', array( &$this->table, &$fields ));
		
		
		//We need to process data as we are sending it back to the client
		
		$item = $this->table;
		
		$params = $this->getParams();
		$params->set('inline',false);
				
		if(!$item->fulltext)
		{	
			$item->text = $item->introtext;
		}	
		elseif ($params->get('force_full', 0) )
		{
			$item->text = $item->introtext.chr(13).chr(13).$item->fulltext;
		}
		else
		{
			$item->text = $item->introtext;
		}
		
   

         //process text
        $leads = $app->getUserState( "inline.arkextensions.flexicontent.leads", array());

        if(in_array($this->id,$leads))
        {
           $item->text = $this->striptagsandcut( $item->text, $params->get('lead_cut_text', 400) );

        }
        elseif($params->get('intro_strip_html',1))
        {
            $item->text = $this->striptagsandcut( $item->text, $params->get('intro_cut_text', 200) );
        }

		//let's detect if any plugin tags are beig used 
		//if so let's inform the system to warn the user
		$message = $this->detectPluginTags($item->text);		
		
		$suppress_arr = array('jcomments', 'jom_comment_bot');
		FLEXIUtilities::suppressPlugins($suppress_arr, 'suppress' );
		
		$dispatcher->trigger('onContentPrepare', array ('com_content.category', &$item, &$params, 0));
	
		// Restore suppressed plugins
		FLEXIUtilities::suppressPlugins($suppress_arr, 'restore' );
												
		return array( 'title'=>$item->title,'data'=>$item->text, 'message'=>$message);	
	}

    protected function striptagsandcut( $text, $chars=null )
	{
		// Convert html entities to characters so that they will not be removed ... by strip_tags
		
               
        $text = html_entity_decode ($text, ENT_NOQUOTES, 'UTF-8');
		
		// Strip SCRIPT tags AND their containing code
		$text = preg_replace( '#<script\b[^>]*>(.*?)<\/script>#is', '', $text );
		
		// Add whitespaces at start/end of tags so that words will not be joined,
		//$text = preg_replace('/(<\/[^>]+>((?!\P{L})|(?=[0-9])))|(<[^>\/][^>]*>)/u', ' $1', $text);
		$text = preg_replace('/(<\/[^>]+?>(?![\:|\.|,|:|"|\']))|(<[^>\/][^>]*>)/u', ' $1', $text);

        
        // Strip html tags
		$cleantext = strip_tags($text);

		// clean additionnal plugin tags
		$patterns = array();
		$patterns[] = '#\[(.*?)\]#';
		$patterns[] = '#{(.*?)}#';
		$patterns[] = '#&(.*?);#';
		
		foreach ($patterns as $pattern) {
			$cleantext = preg_replace( $pattern, '', $cleantext );
		}
		
		// Replace multiple spaces, tabs, newlines, etc with a SINGLE whitespace so that text length will be calculated correctly
		$cleantext = preg_replace('/[\p{Z}\s]{2,}/u', ' ', $cleantext);  // Unicode safe whitespace replacing
		
		// Calculate length according to UTF-8 encoding
		$length = JString::strlen($cleantext);
		
		// Cut off the text if required but reencode html entities before doing so
		if ($chars) {
			if ($length > $chars) {
				$cleantext = JString::substr( $cleantext, 0, $chars ).'...';
			}
		}
		
		// Reencode HTML special characters, (but do not encode UTF8 characters)
		$cleantext = htmlspecialchars($cleantext, ENT_QUOTES, 'UTF-8');
		
		return $cleantext;
	}
	
}