<?php
/*------------------------------------------------------------------------
# Copyright (C) 2012-2015 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

 /**
 *Ark inline content Category Context Class
 *
 * @package     Inlinecontent.Contexts
 * @subpackage  Inlinecontent.contexts.FlexicontentCategory
 */
 
require_once (JPATH_SITE.'/components/com_flexicontent/classes/flexicontent.fields.php');
require_once (JPATH_SITE.'/components/com_flexicontent/classes/flexicontent.helper.php');
 
class ARKContextsFlexicontentCategory extends ARKContextsBase
{


	public function __construct($id)
	{
		JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_flexicontent/tables'); 
		$this->table = 	JTable::getInstance('flexicontent_categories','');
		$this->table->load($id);
		return parent::__construct($id);	
	}	


    public function get($pk = null)
	{
		if($this->id == null)
			return parent::get();	
		
		$this->table->articletext = $this->table->description;

		return parent::get($pk);	
	}
	
	
	
	public function triggerContentPlugins($rawText)
	{
		
		$item = new stdclass;
					
		$item->text = '';
		if(isset($rawText))
		{
			$item->text = $rawText;
			JModelLegacy::addIncludePath(JPATH_SITE.'/components/com_flexicontent/models');
			$model = JModelLegacy::getInstance('category','FlexicontentModel');
			$model->_loadCategoryParams($this->id); //This is a bit naughty here but we get the merge parameters from the model. We may have to do this a different way in future.
			$params = $model->getParams();
			$params->set('inline',false); //set this so that we don't trigger the inline content plugins
			$dispatcher	= JEventDispatcher::getInstance();
			JPluginHelper::importPlugin('content');
			$dispatcher->trigger('onContentPrepare', array ('com_content.article', &$item, &$params, 0));
		}	
			
		return array( 'data'=>$item->text);
	}
			
	public function save($data,$pk = null,$type = 'body')
	{
		if($this->id == null)
			return array( 'title'=>'','data'=>'');	
		
		$item = $item = $this->table;

		if(isset($data['articletext']))
				$data['description'] = base64_decode($data['articletext']);
			else
				$data['title'] = strip_tags($data['title']); 
		
		JPluginHelper::importPlugin('content');
		$dispatcher = JDispatcher::getInstance();
		$dispatcher->trigger('onContentBeforeSave', array('com_flexicontent.category', &$item, false));
			
		$item->save($data);
		
		$dispatcher->trigger('onContentAfterSave', array('com_flexicontent.category', &$item, false));
		
		//Let's save version manually as we cannot use JTableObserverContenthistory in this case!
		$typeAlias = 'com_flexicontent.category';	
		$contenthistoryHelper = new JHelperContenthistory($typeAlias);			
		$contenthistoryHelper->store($item);
		
		//We need to process data as we are sending it back to the client
		
		$item->text = $item->description;
		
		//let's detect if any plugin tags are being used 
		//if so let's inform the system to warn the user
		$message = $this->detectPluginTags($item->text);	

		JModelLegacy::addIncludePath(JPATH_SITE.'/components/com_flexicontent/models');
		$model = JModelLegacy::getInstance('category','FlexicontentModel');
		$model->_loadCategoryParams($this->id); //This is a bit naughty here but we get the merge parameters from the model. We may have to do this a different way in future.
		$params =  $model->_params;
		$params->set('inline',false); //set this so that we don't trigger the inline content plugins
		$dispatcher->trigger('onContentPrepare', array ('com_content.article', &$item, &$params, 0));
												
		return array( 'title'=>$item->title,'data'=>$item->text,'message'=>$message);	
	}
	
	public function version($versionId,$type)
	{
				
		$historyTable = JTable::getInstance('Contenthistory');
		$historyTable->load($versionId);
		$rowArray = JArrayHelper::fromObject(json_decode($historyTable->version_data));
			
		$item = $this->table;

		$item->bind($rowArray);	
		if($type == 'title')
		{
			return array( 'data'=>$item->name);
		}
		$text = '';
		
		$text = $item->description;
	
		return array( 'data'=>$text);
		
	}
	
}
