<?php
/*------------------------------------------------------------------------
# Copyright (C) 2012-2015 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

/**
 *Ark inline content Article Context Class
 *
 * @package     Inlinecontent.Contexts
 * @subpackage  Inlinecontent.contexts.FlexicontentTextarea
 */
 
 require_once (JPATH_SITE.'/components/com_flexicontent/classes/flexicontent.helper.php');
 require_once (JPATH_SITE.'/components/com_flexicontent/classes/flexicontent.fields.php');
 
 
class ARKContextsFlexicontentTextarea extends ARKContextsBase
{


	private $item;

	public function __construct($id)
	{
		JTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_flexicontent/tables'); 
		
		list($item_id,$id) =  explode('_',$id);
		
	    $this->table = 	JTable::getInstance('flexicontent_fields','');

		$this->table->load($id);
		$this->table->item_id = $id;
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
		$query->select('value')
			->from('#__flexicontent_fields_item_relations')
			->where('field_id = '.(int)$id)
			->where('item_id = '.(int)$item_id);
		$db->setQuery($query);	
		$value = $db->loadResult();
		
		$this->table->value = array();
		$this->table->value[0] = $value;
		$this->table->title = '';
		$this->table->parameters = new JRegistry($this->table->attribs);
		
		$this->item = JTable::getInstance('flexicontent_items','');
		$this->item->load($item_id);
		
		parent::__construct($id);		
	}	


    public function get()
	{
	
		if($this->id == null)
			return parent::get();	
     	
		$this->table->articletext = $this->table->value[0];

		return parent::get($pk);	
	}
	
	
	
	public function triggerContentPlugins($rawText)
	{
		
		$item = new stdclass;
		
	
		
		$field = JTable::getInstance('flexicontent_fields','');
		$field->load($this->id);
		$field->value = array();
		$field->value[0] = $rawText;
		$field->parameters = new JRegistry($field->attribs);
			
		FLEXIUtilities::call_FC_Field_Func($field->field_type, 'onDisplayFieldValue', array(&$field, $this->item, null, 'display') );
		
		$item->text = $field->display;
		
		$params = $this->table->parameters;
		$params->set('inline',false);
		$dispatcher	= JEventDispatcher::getInstance();
			
		$suppress_arr = array('jcomments', 'jom_comment_bot');
		FLEXIUtilities::suppressPlugins($suppress_arr, 'suppress' );
		
		JPluginHelper::importPlugin('content');
		$dispatcher->trigger('onContentPrepare', array ('com_content.article', &$item, &$params, 0));
	
		// Restore suppressed plugins
		FLEXIUtilities::suppressPlugins($suppress_arr, 'restore' );
		
		return array( 'data'=>$item->text);
	}
		
		
	public function save($data,$type = 'body')
	{
		if($this->id == null)
			return array( 'title'=>'','data'=>'');	
		
		if(isset($data['articletext']))
		{	
			$data['articletext'] = base64_decode($data['articletext']);	
		} 

		$datenow = JFactory::getDate();
		$this->item->modified = $datenow->toSQL();
		$this->item->modified_by = JFactory::getUser()->get('id');
		
		$last_version = FLEXIUtilities::getLastVersions($this->item->id, true);
		$current_version = FLEXIUtilities::getCurrentVersions($this->item->id, true);
					
		$this->item->save($data);
			
		//We will always be using versioning for inline editing
		
		//Create and store version METADATA information
		
		$db = JFactory::getDBO();
		
		$version = new stdClass();
        $version->item_id		= (int)$this->table->id;
		$version->version_id	= (int)$last_version+1;
		$version->created		= $this->item->modified;
		$version->created_by 	= $this->item->modified_by;
		$version->comment		= '';
		$db->insertObject('#__flexicontent_versions', $version);
		
		
		//Now duplicate lastversion for fields for consistency

		$sql = 'INSERT INTO #__flexicontent_items_versions(version,field_id,item_id,valueorder,value)';
		
		$query = $db->getQuery(true);
		$query->select(array($last_version+1,'field_id','item_id','valueorder','value'))
			->from('#__flexicontent_items_versions')
			->where('version'.' = '. (int)$last_version)
			->where('item_id'.' = '. (int)$this->id);
		$db->setQuery($sql.' '.$query);
		$db->query();	
		
		$files = null;
		FLEXIUtilities::call_FC_Field_Func($field_type, 'onBeforeSaveField', array( &$this->table, &$data, &$files, &$this->item ));
		
					
		$query->clear()
			->update($db->quoteName('#__flexicontent_items_versions'))->set($db->quoteName('value').' = '. $db->quote($data['articletext']))->where('field_id = '. (int) $this->id)
			->where('version'.' = '. (int)$last_version+1)
			->where('item_id'.' = '. (int)$this->id);
			$db->setQuery($query);
			$db->query();
			
		//Store field data 	
		$query->clear()
			->delete('#__flexicontent_fields_item_relations')
			->where('item_id = '.(int)$this->item->id)
			->where('field_id = '.(int)$this->id);
			$db->setQuery($query);
			$db->query();
		
		$obj = new stdClass();
		$obj->field_id 		= $this->id;
		$obj->item_id 		= $this->item->id;
		$obj->valueorder	= 1;
		$obj->value =	$data['articletext'];
		$db->insertObject('#__flexicontent_fields_item_relations', $obj);
		
				
		FLEXIUtilities::call_FC_Field_Func($field_type, 'onAfterSaveField', array( &$this->table, &$data, &$files, &$this->item ));
		
		
		$this->table->value = array($data['articletext']);
		
		FLEXIUtilities::call_FC_Field_Func($this->table->field_type, 'onDisplayFieldValue', array(&$this->table, $this->item, null, 'display') );
				
		//Let's save version manually as we cannot use JTableObserverContenthistory in this case!
		$typeAlias = 'com_flexicontent.textarea';	
		$contenthistoryHelper = new JHelperContenthistory($typeAlias);			
		$this->table->id = $this->id + $this->item->id;
		$description = $this->table->description;
		$this->table->description = $this->table->display;
		$contenthistoryHelper->store($this->table);
		$this->table->id = $this->id;
		$this->table->description = $description; 
		
		//We need to process data as we are sending it back to the client
		
		$item = $this->table;
		$item->title = '';
		
		$item->text = $this->table->display;
		
		$params = $this->table->parameters;
		$params->set('inline',false);
		$dispatcher	= JEventDispatcher::getInstance();
		
		//let's detect if any plugin tags are beig used 
		//if so let's inform the system to warn the user
		$message = $this->detectPluginTags($item->text);
			
		$suppress_arr = array('jcomments', 'jom_comment_bot');
		FLEXIUtilities::suppressPlugins($suppress_arr, 'suppress' );
		
		JPluginHelper::importPlugin('content');
		$dispatcher->trigger('onContentPrepare', array ('com_content.article', &$item, &$params, 0));
	
		// Restore suppressed plugins
		FLEXIUtilities::suppressPlugins($suppress_arr, 'restore' );
		
		return array( 'title'=>$item->title,'data'=>$item->text,'message'=>$message);	
	}
	
	public function version($versionId,$type)
	{
				
		$historyTable = JTable::getInstance('Contenthistory');
		$historyTable->load($versionId);
		$rowArray = JArrayHelper::fromObject(json_decode($historyTable->version_data));
			
		$item = $this->table;

		$item->bind($rowArray);	
		if($type == 'title')
		{
			return array( 'data'=>$item->title);
		}
		$text = '';
		
		$text = $item->display;
	
		return array( 'data'=>$text);
		
	}
}