<?php
/*------------------------------------------------------------------------
# Copyright (C) 2012-2015 WebxSolution Ltd. All Rights Reserved.
# @license - GPLv2.0
# Author: WebxSolution Ltd
# Websites:  http://www.webxsolution.com
# Terms of Use: An extension that is derived from the JoomlaCK editor will only be allowed under the following conditions: http://joomlackeditor.com/terms-of-use
# ------------------------------------------------------------------------*/ 

defined('_JEXEC') or die;

/**
 * Ark Inline content editing Plugin
 *
 * @package     extensions.ARKExtensions
 * @subpackage  extensions.ARKExtensionsBase
 */
class ARKExtensionsFlexicontent extends  ARKExtensionsBase
{

	protected $skipProccessing = false; 

    public static $itemNum = 0;
	
	public static $fired = false;
 	
	public  function __construct($context, $item, $params)
	{
		//call parent construtor
		parent::__construct($context, $item, $params);
		 //set allowable context array for inline editing
		$this->inline_allowed_contexts = array ('com_content.article','com_content.category');
		 
		if($this->app->input->get('arkoption') != 'com_flexicontent')   //If this is really com_flexicontent
			$this->skipProccessing = true; 
		
			
		if(!static::$fired && $context == 'com_content.category')
		{		
			$document = JFactory::getDocument();
			$document->addScriptDeclaration(
			"jQuery(document).ready(function()
				{
					CKEDITOR.on( 'instanceCreated', function( evt ) 
					{
						var editor = evt.editor,
							overflow = '';
						
						editor.on('focus',function()
						{
							var element = this.editable().getAscendant('li');
							if(element)
							{	
								overflow = element.getStyle('overflow');
								if(overflow)
									element.removeStyle('overflow');
							}	
							
						});

						editor.on('blur',function()
						{
							if(overflow)
							{	
								var element = this.editable().getAscendant('li');
								element.setStyle('overflow',overflow);
							}	
						});
					});	
				});
			");
			static::$fired = true;
		}
    }	
	
	
	public function prepare()
	{
		if($this->skipProccessing) // bail out
			return false;
	
	    //Are we allowed to edit in this context 
			
		if($this->context != 'com_content.article')    //override base check as we only fire this for category description
		{
			return false;
		}
		
		if(isset($this->item->field_type) && $this->item->field_type == 'textarea')
		{	
			
			//Permisson Check
				
			//Set Asset number 
			$this->id = $this->item->item_id;
			$asset = 'com_content.article.'.$this->id;
			$createdBy = $this->item->created_by;
			
			$user = JFactory::getUser();		
			//can user edit item if not then bail
			if (!($user->authorise('core.edit', $asset) || ($user->authorise('core.edit.own', $asset) && $user->id == $createdBy)) )
			{
				return false;
			}		
			
						
			//need to override base class here for following check for categories
			/*filter article to see if it is being used to load a module if so skip it
			[widgetkit]
			{loadmodule}
			{loadposition}
			{module}
			{modulepos}
			{modulepos}
			{component}
			{article(s)}
			*/
				
			$text = $this->item->value[0];
			
			$test = preg_match('/\{(?:loadmodule|loadposition|module|modulepos|component|articles?)\s+(.*?)\}/i',$text);
		
			if(!$test)
				$test = preg_match('/\[widgetkit\s+(.*?)\]/i',$text);
			
			if($test)
			{	
				return false;
			}
		

			$this->type = 'textarea';
		
			$dispatcher = JEventDispatcher::getInstance();
			JPluginHelper::importPlugin('inline');
			$dispatcher->trigger('editable',array(&$this->item->text, array('id'=>$this->id.'_'.$this->item->fieldid,'context'=>$this->dataContext,'itemtype'=>$this->type)));
		
			return true;
	
		}
		elseif(isset($this->item->introtext))
		{
			return false;
		}
			
	
				
		//Set Data Item Type
		$this->type = 'category';
		
		//Permisson Check
		if(!isset($this->id))
        {
		    $id = $this->app->input->get('id',0);
            $this->id = $id ? $id : 0;   
        }		
		
		//Set Asset number 
		$asset = 'com_content.article.' . $this->id;
		
		$table = JTable::getInstance('category');
		$table->load($this->id);
		$createdBy = $table->created_user_id;
		
		$user = JFactory::getUser();		
		//can user edit item if not then bail
		if (!($user->authorise('core.edit', $asset) || ($user->authorise('core.edit.own', $asset) && $user->id == $createdBy)) )
		{
			return false;
		}	

		//need to override base class here for following check for categories
		/*filter article to see if it is being used to load a module if so skip it
		[widgetkit]
		{loadmodule}
		{loadposition}
		{module}
		{modulepos}
		{modulepos}
		{component}
		{article(s)}
		*/
		$text = $table->decsription;
		
		
		$test = preg_match('/\{(?:loadmodule|loadposition|module|modulepos|component|articles?)\s+(.*?)\}/i',$text);
	
		if(!$test)
			$test = preg_match('/\[widgetkit\s+(.*?)\]/i',$text);
		
		if($test)
		{	
			return;
		}
		
		return parent::prepare();	 
	}	
	
		
	public function display()
	{
           
       if($this->skipProccessing) // bail out
			return false;
		
	    //is this item already proccessed
        
		if(isset($this->item->proccessedInline) && $this->item->proccessedInline)
			return false;	
		
		if(!isset($this->item->introtext)) //is this the article typee
		{
			return false;
		}
		        
        //Set Data Item Type
		$this->type = str_replace($this->app->input->get('option').'.','',$this->context);
		
		if($this->type == "category") //we are in blog view so set type to blog
		{
			$this->type = 'blog';
		}
		
        //Permisson Check
				
		//Set Asset number 
		$asset = 'com_content.article.'.$this->id;
		$createdBy = $this->item->created_by;
		
		$user = JFactory::getUser();		
		//can user edit item if not then bail
		if (!($user->authorise('core.edit', $asset) || ($user->authorise('core.edit.own', $asset) && $user->id == $createdBy)) )
		{
			return false;
		}		
	
		$this->params->set('title_cut_text',500); //override this value to ensure we do not cut the title


                            
        if( is_null(static::$staticParams))
        {
            static::$staticParams = clone $this->params;
        }

        if($this->type == 'blog')
        {
            //we neeed to some special processing here to preserve our html tags
            if($this->params->set('lead_strip_html',1) && $this->app->input->get('limitstart') == 0)
            {
                if(static::$itemNum < $this->params->get('lead_num',1))
                {
                    static::$itemNum++;

		                //Have to use static parameter as we are getting a copy of the original params passsed in and not a reference
                       //each time this event is fired
                        static::$staticParams->set('lead_strip_html',0);
                         if(strlen($this->item->text) >  (int) $this->params->get('lead_cut_text', 400) )
                            static::$staticParams->set('show_readmore', 1); 
                            //Modify text here as this should be the last content plugin fired
                        $this->item->text = $this->striptagsandcut( $this->item->text, $this->params->get('lead_cut_text', 400) );
						$leads = array();
						if(static::$itemNum > 1)
							$leads = $app->getUserState( "inline.arkextensions.flexicontent.leads", array());
						$leads[] = $this->id;
						$this->app->setUserState( "inline.arkextensions.flexicontent.leads", $leads);
	
               }
               else
               {
                    static::$staticParams->set('intro_strip_html',0);
                    if(strlen($this->item->text) >  (int) $this->params->get('intro_cut_text', 200) )
                        static::$staticParams->set('show_readmore', 1); 
                        //Modify text here as this should be the last content plugin fired
                    $this->item->text = $this->striptagsandcut( $this->item->text, $this->params->get('intro_cut_text', 200) );
	            }

      
            }
            else
            {
                static::$staticParams->set('intro_strip_html',0);
                if(strlen($this->item->text) >  (int) $this->params->get('intro_cut_text', 200) )
                    static::$staticParams->set('show_readmore', 1); 
                 //Modify text here as this should be the last content plugin fired
                $this->item->text = $this->striptagsandcut( $this->item->text, $this->params->get('intro_cut_text', 200) );
			}
        }
        
        if(!parent::display())
			return false;

		return true; 
	}

    protected function striptagsandcut( $text, $chars=null )
	{
		// Convert html entities to characters so that they will not be removed ... by strip_tags
		$text = html_entity_decode ($text, ENT_NOQUOTES, 'UTF-8');
		
		// Strip SCRIPT tags AND their containing code
		$text = preg_replace( '#<script\b[^>]*>(.*?)<\/script>#is', '', $text );
		
		// Add whitespaces at start/end of tags so that words will not be joined,
		//$text = preg_replace('/(<\/[^>]+>((?!\P{L})|(?=[0-9])))|(<[^>\/][^>]*>)/u', ' $1', $text);
		$text = preg_replace('/(<\/[^>]+>(?![\:|\.|,|:|"|\']))|(<[^>\/][^>]*>)/u', ' $1', $text);
		
		// Strip html tags
		$cleantext = strip_tags($text);

		// clean additionnal plugin tags
		$patterns = array();
		$patterns[] = '#\[(.*?)\]#';
		$patterns[] = '#{(.*?)}#';
		$patterns[] = '#&(.*?);#';
		
		foreach ($patterns as $pattern) {
			$cleantext = preg_replace( $pattern, '', $cleantext );
		}
		
		// Replace multiple spaces, tabs, newlines, etc with a SINGLE whitespace so that the text length will be calculated correctly
		$cleantext = preg_replace('/[\p{Z}\s]{2,}/u', ' ', $cleantext);  // Unicode safe whitespace replacing
		
		// Calculate length according to UTF-8 encoding
		$length = JString::strlen($cleantext);
		
		// Cut off the text if required but reencode html entities before doing so
		if ($chars) {
			if ($length > $chars) {
				$cleantext = JString::substr( $cleantext, 0, $chars ).'...';
			}
		}
		
		// Reencode HTML special characters, (but do not encode UTF8 characters)
		$cleantext = htmlspecialchars($cleantext, ENT_QUOTES, 'UTF-8');
		
		return $cleantext;
	}
}