<?php
/**
 * @package   System - ZOO Event
 * @author    YOOtheme http://www.yootheme.com
 * @copyright Copyright (C) YOOtheme GmbH
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemFlexicontentInlineHistory extends JPlugin {

	public $app;
	
	/**
	 * onAfterInitialise handler
	 *
	 * Adds ZOO event listeners
	 *
	 * @access public
	 * @return null
	 */
	
	public function onAfterRoute()
	{
		
		//Inline editing is only enabled for frontend editing	
		if ($this->app->isAdmin())
		{
			return;
		}
		
        $user = JFactory::getUser();
		
		//if user is guest lets bail
		if($user->get('guest'))
		{
			return;
		}
			
		if($this->app->input->get('option') == 'com_contenthistory' &&  $this->app->input->get('type_alias') == 'com_flexicontent.textarea')
		{		
			$uuid = $this->app->input->get('item_id',0);
			
			if(is_int($uuid ))
				return;
			
			if(!$uuid)
				return;
		
			list($item_id,$field_id) = explode('_',$uuid);
			
			$item_id = (int) $item_id + (int) $field_id;
			
			$this->app->input->set('item_id',$item_id);
		
		}

	
	}	
	

}
